' Generic utility routines that can be used anywhere.
' The routines in this files are language independent.
'
' HISTORY
' Aug-2005	GenoPro			Creation


'===========================================================
' The global object g_collFootnotes is used to maintain a list of unique footnotes
' to be displayed at the bottom of the page
Dim g_collFootnotes
' declare other global variables
Dim g_cxPictureSizeLarge, g_cyPictureSizeLarge, g_cxPictureSizeSmall, g_cyPictureSizeSmall, g_cxyPicturePadding
Dim g_fHidePictureName, g_fHideFamilyDetails, g_fCollapseNotes, g_fCollapseReferences, g_fHideNameTreeIndex
Dim g_oGenoMapSuffix, g_fUseTreeIndexes, g_fHideOtherRelationships, g_fJoinPlaceNames, g_fJoinSourceCitationNames
Dim g_cTocExpand, g_strPictureSlider, g_fUsePictureThumbnails, g_fUsePictureId, g_fShowPictureDetails
Dim g_fGoogleMaps, g_strGoogleMapsApiKey, g_strGoogleMapsZoom, g_fGoogleMapsLink, g_fGoogleMapsOverview
Dim g_cxGoogleMapsSmall, g_cyGoogleMapsSmall, g_cxGoogleMapsLarge, g_cyGoogleMapsLarge
Dim g_fSvgExpandFrame, g_fSvgZoomExtent

Dim g_RegEx, g_RegEx_PPN, strTemp

Dim g_strBaseUrl, g_strPrivateFolder, g_nPrivateFolder
Dim g_fDebug

' Initialize the global variables required to display individuals, families and pictures
' Those global variables begin by "g_" and are used by the routines found in multiple files.
Sub InitGlobalVariables

	Dim strImgSize, strPicturePadding

	strImgSize = GetParameter("PictureSizeLarge")
	g_cxPictureSizeLarge = Util.GetWidth(strImgSize)
	g_cyPictureSizeLarge = Util.GetHeight(strImgSize)
	strImgSize = GetParameter("PictureSizeSmall")
	g_cxPictureSizeSmall = Util.GetWidth(strImgSize)
	g_cyPictureSizeSmall = Util.GetHeight(strImgSize)
	strPicturePadding = GetParameter("PicturePadding")
	If (strPicturePadding <> "") Then
		g_cxyPicturePadding = strPicturePadding + 0	' Convert the string to integer
	End If

	g_fUseTreeIndexes = (GetParameter("fUseTreeIndexes") = "Y")
	g_fHidePictureName = (GetParameter("fHidePictureName") = "Y")
	g_fShowPictureDetails = (GetParameter("fShowPictureDetails") = "Y")
	g_fHideFamilyDetails = (GetParameter("fHideFamilyDetails") = "Y")
	g_fHideNameTreeIndex = (GetParameter("fHideNameTreeIndex") = "Y")
	g_fJoinPlaceNames = (GetParameter("fJoinPlaceNames") = "Y")
	g_fJoinSourceCitationNames = (GetParameter("fJoinSourceCitationNames") = "Y")
	g_fCollapseNotes = (GetParameter("fCollapseNotes") = "Y")
	g_fCollapseReferences = (GetParameter("fCollapseReferences") = "Y")


	g_cTocExpand = GetParameter("cTocExpand") + 0

	Dim nPictureInterval
	nPictureInterval = GetParameter("PictureInterval") + 0
	If nPictureInterval < 1000  Or   nPictureInterval > 10000 Then Report.LogError "Config.xml parameter 'PictureSlider' must be in range 1000 - 10000 (milliseconds)"
	If nPictureInterval < 1000  Then nPictureInterval = 1000
	If nPictureInterval > 10000 Then nPictureInterval = 10000

	g_strPictureSlider = (-30+(30-9)*((10000 - nPictureInterval)/(10000-1000))) & ""

	g_fUsePictureThumbnails = (GetParameter("fUsePictureThumbnails") = "Y")
	g_fUsePictureId = (GetParameter("fUsePictureId") = "Y")

	g_strGoogleMapsApiKey = (GetParameter("GoogleMapsApiKey"))
	g_fGoogleMaps = (GetParameter("GoogleMaps") = "Y")
	g_fGoogleMapsLink = (GetParameter("fGoogleMapsLink") = "Y")
	g_fGoogleMapsOverview = (GetParameter("fGoogleMapsOverview") = "Y")
	g_strGoogleMapsZoom = (GetParameter("GoogleMapsZoom"))
	g_cxGoogleMapsSmall  = Util.GetWidth( GetParameter("GoogleMapsSmall"))
	g_cyGoogleMapsSmall = Util.GetHeight(GetParameter("GoogleMapsSmall"))
	g_cxGoogleMapsLarge  = Util.GetWidth( GetParameter("GoogleMapsLarge"))
	g_cyGoogleMapsLarge = Util.GetHeight(GetParameter("GoogleMapsLarge"))

	g_fSvgExpandFrame = (GetParameter("fSvgExpandFrame") = "Y")
	g_fSvgZoomExtent = (GetParameter("fSvgZoomExtent") = "Y")

	Set g_oGenoMapSuffix = Session("oGenoMapSuffix")
	
	' Create an empty collection to keep all the footnotes on the generated page
	Set g_collFootnotes = Util.NewGenoCollection()

'	Create array of regular expressions for possessive proper noun conversion (see StrPossessiveProperNoun function in Lang.vbs)

	strTemp = Dic("PossessiveProperNoun")
	g_RegEx_PPN = split(Replace(strTemp,";",":"),":")
	Set g_RegEx = New RegExp
	g_RegEx.IgnoreCase = True

	' Save the base URL
	g_strBaseUrl = ReportGenerator.PathOutputHttp
	If g_strBaseUrl = "" Then g_strBaseUrl = "file:///" & Replace(ReportGenerator.PathOutput,"\","/")
	g_strPrivateFolder = "private/"
	g_nPrivateFolder = Len(g_strPrivateFolder)
	g_fDebug = False
	

End Sub

Function GetParameter(strParam)
	Dim oNode
	Set oNode = Session("Global").selectSingleNode(strParam)
	If Not Util.IsNothing(oNode) Then
		GetParameter = oNode.text
	Else
		GetParameter = Report.Parameters(strParam)
	End If
End Function


Sub WriteHtmlButtonToggle(style)
	Select Case style
	Case "Notes"
		Report.WriteFormattedLn "<img src='images/{}.jpg' class='buttonicon2' name='toggle' onclick='javascript:ToggleTree(this.name,"""");' alt='{1} {2}' title='{1} {2}'/>", Util.IfElse(g_fCollapseNotes,"expand","collapse"), Dic("TocExpandCollapseAll"), Dic(style)
	Case "References", "OtherDetails"
		Report.WriteFormattedLn "<img src='images/{}2.jpg' class='buttonicon2' name='toggle2' onclick='javascript:ToggleTree(this.name,""2"");' alt='{1} {2}' title='{1} {2}'/>", Util.IfElse(g_fCollapseReferences,"expand","collapse"), Dic("TocExpandCollapseAll"), Dic(style)
	Case "Entries"
		Report.WriteFormattedLn "<div class='buttontoc'><img src='images/{}2.jpg' class='buttonicon2' name='toggle2' onclick='javascript:ToggleTree(this.name,""2"");' alt='{1} {2}' title='{1} {2}'/></div>", Util.IfElse(fTreeOpen,"collapse","expand"), Dic("TocExpandCollapseAll"), Dic(style)
	Case "HidePopUp"  ' close 'popup' frame
		Report.WriteFormattedLn "<img src='images/close24.gif' class='buttonicon2' onclick='javascript:hidePopUpFrame(event);' alt='{0}' title='{0}'/>", Dic("AltHidePopUpFrame")
	End Select
End Sub

' Write the HTML code to display all the pictures of an individual, family or place
Sub WriteHtmlPictures(i, cxWidthMax, cyHeightLimit, cxyPadding, strAlign, strHeading, fNoName)
	Dim p, pic
	Set p = i.Pictures.Primary	' Get the primary picture of the individual or family	
	' Get the dimension of the picture.  This will load the picture if not already loaded
	If (p.PictureDimension <> "") Then    
		Dim strId, strDimension,  cyHeightMax, cyHeight
		strId = i.ID
		Report.WriteFormattedLn "{}<div id='idPVp_{}'>", strHeading, strId
	'	find tallest picture
		For Each pic in i.Pictures
			strDimension = pic.PictureDimension(cxWidthMax & "x" & cyHeightLimit)
			cyHeight = Util.GetHeight(strDimension)
			If cyHeight > cyHeightMax Then cyHeightMax = cyHeight
		Next
		WriteHtmlPicture p, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthMax, cyHeightLimit
		Report.Write "</div>"
		WriteHtmlNamePicture i, p

		If (i.Pictures.Count > 1) Then
			' Generate the code to create a slide show of pictures
			WriteHtmlButtonPV strId, "Play"
			WriteHtmlButtonPV strId, "Pause"
			WriteHtmlButtonPV strId, "Prev"
			WriteHtmlButtonPV strId, "Next"
			Report.WriteFormattedLn "<img id='idPVslider_{2}' src='images/slider.gif' style='position:relative;' width='30' height='16' alt='{0}' title='{0}'/>" & _
					"<img onmousemove='sliderMouseMove(event);' onmousedown='sliderMouseDown(event);' onmouseout='sliderMouseUpOut(event);' onmouseup='sliderMouseUpOut(event);' " & _
						"style='position:relative;left:{1}px;' src='images/knob.gif' width='9' height='15' alt='{0}' title='{0}'/>", Dic("PV_Speed"), g_strPictureSlider, strId
			Report.WriteFormattedLn "<select class='hide' id='idPVs_{0}' onchange=""PV_PickCore('{0}', 0);"">", strId
			For Each pic In i.Pictures
				' Load the picture and update its cache if necessary
				If (pic.PictureDimension <> "") Then
					Dim strImg, strSelected
					strImg = StrHtmlPicture(pic, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthMax, cyHeightLimit)
					strSelected = Util.IfElse(pic.ID <> p.ID, "", " selected=""selected""")
					If g_fShowPictureDetails Then
						Report.WriteFormattedLn "<option{0} class='hide' value='{1&t}{5&t}{2&t}{5&t}{3&t}{5&t}{4&t}' ></option>", _
							strSelected, strImg, Util.IfElse(fNoName, StrHtmlHyperlink(pic), ""), Util.HtmlEncode(LanguageDictionary.FormatPhrase("PhPictureDetails", Util.IfElse(fNoName, "", StrHtmlTag(Trim(pic.Name),"strong")), pic.Date.ToStringNarrative, StrHtmlHyperlink(pic.Place), StrHtmlHyperlink(pic.Source))), pic.Description, chr(31)
					Else
						Report.WriteFormattedLn "<option{0} class='hide' value='{1&t}{3&t}{2&t}' ></option>", _
							strSelected, strImg, StrHtmlHyperlink(pic), chr(31)
					End If
				End If
			Next
			Report.WriteBr "</select>"
		End If
	End If
End Sub

Sub WriteHtmlPicturesLarge(i, strAlign, strHeading, fNoName)
	WriteHtmlPictures i, g_cxPictureSizeLarge, g_cyPictureSizeLarge, g_cxyPicturePadding, strAlign, strHeading, fNoName
End Sub

Sub WriteHtmlPicturesSmall(i, strAlign, fNoName)
	WriteHtmlPictures i, g_cxPictureSizeSmall, g_cyPictureSizeSmall, g_cxyPicturePadding, strAlign, "", fNoName
End Sub

Sub WriteHtmlPictureSmall(p, strAlign)
	WriteHtmlPicture p, g_cxPictureSizeSmall, g_cyPictureSizeSmall, g_cxyPicturePadding, strAlign, g_cxPictureSizeSmall, g_cyPictureSizeSmall
End Sub

Sub WriteHtmlPicture(p, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthLimit, cyHeightLimit)	
	Dim strDimension, cxWidth, cyHeight, cxMargin, cyMargin, cxMarginL, cxMarginR, strAttributesHTML, strFloat, strThumbnail, i
	strThumbnail = p.Path.Report
	If g_fUsePictureThumbnails Then
		i = InstrRev(strThumbnail, "/")
		strThumbnail = Mid(strThumbnail,1,i) & cxWidthLimit & "x" & cyHeightLimit & "/" & mid(strThumbnail,i+1)
	End If
        strDimension = p.PictureDimension(cxWidthMax & "x" & cyHeightMax)
	cxWidth = Util.GetWidth(strDimension)
	cyHeight = Util.GetHeight(strDimension)

	cxMargin = (cxWidthMax - cxWidth) \ 2
	If (cxMargin < 0) Then cxMargin = 0
	cyMargin = (cyHeightMax - cyHeight) \ 2
	If (cyMargin < 0) Then cyMargin = 0
	strFloat=""
	cxMarginL = cxMargin
	If (strAlign = "right") Then cxMarginL = cxMarginL + cxyPadding
	cxMarginR = cxMargin
	If (strAlign = "left") Then
		cxMarginR = cxMarginR + cxyPadding
	End If
    	strAttributesHTML = Util.FormatString(" width='{}px' height='{}px' class='pic{}' style='margin:{}px {}px {}px {}px;'", cxWidth, cyHeight, strAlign, cyMargin, cxMarginR, cyMargin, cxMarginL)
	Report.WriteFormattedLn "<img src='{}'{} onclick='viewPic(""{&j}"")' alt='{&t}' title='{3&t}'/>", strThumbnail, strAttributesHTML, p.Path.report, Util.FormatPhrase(Dic("PhPictureTooltip"), "", p.Date.ToStringNarrative, p.Place.NameNarrative, p.Source)
End Sub
Sub WriteHtmlNamePicture(o, p)
	Dim strId
	strId = o.ID
	If Not g_fHidePictureName Then
		Report.WriteFormattedLn "<div class='caption' id='idPVn_{}'>{}</div>", strId, StrHtmlHyperlink(p)
	End If
End Sub

' Same as WriteHtmlPicture() however returns a string containing the HTML code from what should be written to the output buffer
Function StrHtmlPicture(p, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthLimit, cyHeightLimit)
	Dim cchBuffer
	cchBuffer = Report.BufferLength
	WriteHtmlPicture p, cxWidthMax, cyHeightMax, cxyPadding, strAlign, cxWidthLimit, cyHeightLimit
	StrHtmlPicture = Report.Buffer(cchBuffer)	' Get the text from the output buffer
	Report.BufferLength = cchBuffer	' Truncate the buffer to its original length
End Function


' Write the HTML code to generate a button (Play, Pause, Next, Prev) of the Picture Viewer (PV).
Sub WriteHtmlButtonPV(strId, strVerb)
	Report.WriteFormattedLn "<a href=""JavaScript:PV_{1}('{0}');"" {2}><img src='images/PV_{1}.gif' border='0' alt='{3}' title='{3}'/></a>", strId, strVerb, StrMouseOver(Dic("PV_" & strVerb)), Dic("PV_" & strVerb)
End Sub


' Return a string containing the HTML code to display the gender of the individual.
Function StrHtmlImgGender(i)
	StrHtmlImgGender = Util.FormatString("<img src='images/gender_{}.gif' class='icon' alt='{&t}' title='{1&t}' /> ", i.Gender.Id, i.Gender)
End Function

Function StrHtmlImgFamily(f)
	Dim strGender0, strGenders
	strGenders = "MF"
	strGender0 = f.Parents(0).Gender.ID
	If (strGender0 = f.Parents(1).Gender.ID) Then
		' Same-sex couples
		Select Case strGender0
			Case "M"
				strGenders = "MM"
			case "F"
				strGenders = "FF"
		End Select
	End If
	' strGenders = ""	' Enable this line if you want a generic icon for a family
	StrHtmlImgFamily = Util.FormatString("<img src='images/family_{}.gif' class='icon' alt='{}' title='{1}'/> ", strGenders, Dic("Family"))
End Function

Function StrHtmlImgPhoto(obj)
	Select Case obj.Class
	Case "Picture"
		fPrivateFolder = Eval(Left(Report.FileOutput,g_nPrivateFolder)=g_strPrivateFolder)
		if fPrivateFolder Then strHref = g_strPrivateFolder & "pictures.htm" Else strHref = "pictures.htm"
		StrHtmlImgPhoto = Util.FormatString("<img src='images/space.gif' width='16' alt=''/>&nbsp;<a href='{}#{}'><img src='images/photo.gif' class='icon' alt='' title='' />&nbsp;{&t}</a>", _
				strHref, obj.ID, Util.IfElse(Trim(obj.Name) <> "", Trim(obj.Name), "(" & obj.ID &")"))
				

	Case Else
		cPictures = obj.Pictures.Count
		If (cPictures > 0) Then
			StrHtmlImgPhoto = Util.FormatString("&nbsp;<a href='{}'><img src='images/photo.gif' class='icon' alt='{}' title='{1}' /></a>", _
				obj.Href, Dic.PlurialCount("Picture", cPictures))
		End If
	End Select
End Function

Function StrHtmlImgPhotoLink(i, target)
	cPictures = i.Pictures.Count
	If (cPictures > 0) Then
		StrHtmlImgPhotoLink = Util.FormatString("&nbsp;<a href='{}#{}'><img src='images/photo.gif' class='icon' alt='{}' title='{2}' /></a>", _
			target, i.ID, Dic.PlurialCount("Picture", cPictures))
	End If
End Function

' Link to the .gno file if present in the report
Function StrHtmlImgFileGno(i)
	strFileFamilyTreeGno = ReportGenerator.ExtraFiles("FamilyTree.gno")
	If (strFileFamilyTreeGno <> "") Then
		StrHtmlImgFileGno = Util.FormatString(" <a href='{}?id={}'><img src='images/gno.gif' class='icon' alt='{&t}' title='{2&t}'/> </a> ", strFileFamilyTreeGno, i.Id, Dic.FormatString("FmtAltViewInGnoFile", i.Name))
	End If
End Function

Function StrHtmlImgFileSvg(obj)
	Dim fFlag, strFileGenoMap, xyTopRight, xyTopLeft, xyStartRight, xyStartLeft, xTopCenter, pos
	fFlag = ReportGenerator.NegateAxisY
	ReportGenerator.NegateAxisY = True
	fPrivateFolder = Eval(Left(Report.FileOutput,g_nPrivateFolder)=g_strPrivateFolder)
	If fPrivateFolder Then
		strFileGenoMap = obj.Position.GenoMap.Session("PathGenoMapPrivate")
	Else
		strFileGenoMap = obj.Position.GenoMap.Session("PathGenoMap")
	End If
	If (strFileGenoMap <> "") Then
		Select Case obj.Class
		Case "Individual"	
			StrHtmlImgFileSvg = Util.FormatString(" <a href='{}?x={},y={},highlight=true' target='popup'><img src='images/svg.gif' class='icon' alt='{&t}' title='{3&t}'/> </a> ", strFileGenoMap, obj.Position.x, obj.Position.y, Dic.FormatString("FmtAltViewInSvgFile", obj.Name))
		Case "Family"
			Set pos = obj.Position
			xyTopRight=split(pos.Top.Right,",")
			xyTopLeft=split(pos.Top.Left,",")
			xyStartRight=split(pos.Bottom.Right,",")
			xTopCenter=xyTopLeft(0)+ ( xyTopRight(0) - xyTopLeft(0) ) / 2
			If uBound(xyStartRight) > 0 Then	' bottom line present, so centre highlight on top of vertical line
				StrHtmlImgFileSvg = Util.FormatString(" <a href='{}?x={},y={},highlight=true' target='popup'><img src='images/svg.gif' class='icon' alt='{&t}' title='{3&t}' /> </a> ", strFileGenoMap, obj.Position.x, obj.Position.y, Dic.FormatString("FmtAltViewInSvgFile", obj.Name))
			Else					' centre highlight on mid-point of family relationship
				StrHtmlImgFileSvg = Util.FormatString(" <a href='{}?x={},y={},highlight=true' target='popup'><img src='images/svg.gif' class='icon' alt='{&t}' title='{3&t}' /> </a> ", strFileGenoMap, xTopCenter, xyTopRight(1), Dic.FormatString("FmtAltViewInSvgFile", obj.Name))
			End If
		End Select
	End If
	ReportGenerator.NegateAxisY = fFlag
End Function

' Return individuals name if not blank otherwise if not null generate substitute text for unknown individual
Function StrNameNN(i)
If i.Name <> "" Then
	StrNameNN = i.Name
ElseIf not Util.IsNothing(i) Then
	StrNameNN = Dic("_NoName")
Else
	StrNameNN = ""	
End If
End Function

' Like ToHtmlHyperlinkNN method except returns blank if Individual object is empty or nothing
Function StrHtmlHyperlinkNN(obj)
	Select Case obj.class
	Case "Individual"
		If obj.Name <> "" Then 
			StrHtmlHyperlinkNN = Replace(obj.ToHtmlHyperlink,">"," target='detail' onclick='javascript:hidePopUpFrame();' >",1,1)
		Else
			StrHtmlHyperlinkNN = Util.HtmlEncode(StrNameNN(obj))
		End If
	End Select
End Function

Function StrHtmlHyperlink(obj)
	Select Case obj.Class
	Case "Individual"
		StrHtmlHyperlink = Replace(obj.ToHtmlHyperlink,">"," target='detail' onclick='javascript:hidePopUpFrame();' >",1,1)
	Case "Place"
		StrHtmlHyperlink=Util.FormatString(Dic("_FmtPlaceNarrative"), Util.FirstNonEmpty(obj.Prefix, Dic("PlacePrefixDefault")),Util.FormatString("<a href='place-{1}.htm' onclick='javascript:showPopUpFrame("""");' target='popup'>{0&t}</a>", JoinPlaceNames(obj, obj.Name, true), obj.ID))
	Case "Picture"
		StrHtmlHyperlink=Util.FormatString("<a href='picture-{1}.htm' onclick='javascript:showPopUpFrame("""");' target='popup' title='{2&t}'>{0&t}</a>", Util.IfElse(g_fUsePictureId, obj.ID, Util.FirstNonEmpty(Trim(obj.Name), Dic("PictureDetails"))), obj.ID, Dic("PictureDetailsTip"))
	Case "SourceCitation"
		StrHtmlHyperlink=Util.FormatString(" <a href='source-{1}.htm' onclick='javascript:showPopUpFrame("""");' target='popup'>{0&t}</a>", JoinSourceCitationNames(obj, obj.title, true), obj.ID)
	Case Else
			StrHtmlHyperlink = ""
	End Select
End Function

Function StrHtmlHyperlinkTag(obj, strTag)
	Select Case obj.Class
	Case "Individual"
		StrHtmlHyperlinkTag = Replace(obj.ToHtmlHyperlink,">" & obj.Name & "<"," target='detail' onclick='javascript:hidePopUpFrame();' >" & Util.HtmlEncode(obj.TagValue(strTag)) & "<",1,1)
	End Select
End Function
	

Function StrHtmlHyperlinkPlace(obj)
' Like StrHtmlHyperlink except no preposition included
	Select Case obj.Class
	Case "Place"
		StrHtmlHyperlinkPlace=Util.FormatString(" <a href='place-{1}.htm' onclick='javascript:showPopUpFrame("""");' target='popup'>{0&t}</a>", JoinPlaceNames(obj, obj.Name, true), obj.ID)
	Case Else
			StrHtmlHyperlinkPlace = ""
	End Select
End Function

Function StrHtmlTag(strValue, strTag)
	If strValue <> "" Then
		StrHtmlTag = "<" & strTag & ">" & strValue & "</" & strTag & ">"
	End If
End Function

' Generate the code to display text at the bottom of the status bar when the mouse is over a link or an image
Function StrMouseOver(s) 
	StrMouseOver = Util.FormatString("onmouseover=""return ss('{&j}')"" onmouseout=""cs()"" title='{0&t}'", s)
End Function

Function CustomTag(obj,tag)
On Error Resume Next
CustomTag = obj.TagValue(tag)
End Function

Sub WriteHtmlAdditionalInformation(obj)
' Write details of this object's Custom Tags to the report
'
	Dim oCustomTagRepertory, oCustomTagDictionary, Layout, Layouts, i, j, cchBufferBegin, cchBufferStart, cchBufferNow
	Dim strCustomTagData, strCustomTagDesc, strPrivate, strTag, strFmtTemplate, Args()
	strPrivate = LanguageDictionary.Peek("Private")
	cchBufferBegin = Report.BufferLength
	Set oCustomTagRepertory = Session("oCustomTagRepertory")

	Report.WriteBr	"<div class='clearleft'><ul class='xT'>"
	Report.WriteFormattedLn "    <li class='xT2-{} xT-h' onclick='xTclk(event,""2"")'>", Util.IfElse(g_fCollapseReferences, "c", "o")
	Report.WriteFormattedLn "<a name='Additional Information'></a><h3 class='xT-i inline'>{&t} {&t}</h3><ul class='xT-h'>", Dic(obj.Class), Dic("HeaderAdditionalInformation")

	If obj.Class = "Individual" Then ' List any External Hyperlink, Blood Type, Social or Emotional Relationships here
		cchBufferNow = Report.BufferLength
		If obj.Hyperlink <> "" Then Report.WritePhraseDic "PhExternalLink", Util.FormatString("<a href='{0}'>{0}</a>", obj.Hyperlink)
		Report.WritePhraseDic("PhBloodType"), obj.Name.short, obj.Birth.BloodType, obj.IsDead=false
		If Report.BufferLength > cchBufferNow Then ' some phrase written
			cchBufferBegin= -1	  ' indicate data present in Additional Information section
		End If
		cchBufferStart = Report.BufferLength
		Report.WriteLn "<br /><li class='xT2-o xT-h' onclick='xTclk(event,""2"")'>"
		Report.WriteFormattedLn "<span class='xT-i subhead bold'>{&t}</span><ul class='xT-h'><li>", Dic("Relationships")
		cchBufferNow = Report.BufferLength
		WriteHtmlRelationships obj
		If Report.BufferLength > cchBufferNow Then ' some relationships written
			cchBufferBegin = -1	  ' indicate data present in Additional Information section
			Report.WriteLn "</li></ul></li><div class='clearleft'></div>"
		Else 
			Report.BufferLength = cchBufferStart
		End If
	End If
	If oCustomTagRepertory.KeyCounter(obj.Class) > 0 Then ' Custom tags exist for this object
		Layouts = oCustomTagRepertory.Entry(obj.Class).Count
		Set oCustomTagDictionary = oCustomTagRepertory(obj.Class)
	End If

	For i = 1 to Layouts - 1

		Layout = oCustomTagRepertory.Entry(obj.Class).Object(i)
		cchBufferStart = Report.BufferLength


		' check if this Custom Tag Dialog Layout has an associated phrase in the Language Dictionary
		strFmtTemplate = LanguageDictionary.Peek("PhCT_" & Layout(0))

		If strFmtTemplate <> "" Then			' create a custom phrase
			Report.WriteLn "<br /><li class='xT2-o xT-h' onclick='xTclk(event,""2"")'>"
			Report.WriteFormattedLn "<span class='xT-i subhead bold'>{&t}</span><ul class='xT-h'><li>", Layout(1)
			ReDim Args(Ubound(Layout)+8)
			Args(0) = obj & ""  ' default property e.g. name
			Select Case obj.Class
			Case "Individual"
				Args(0) = obj.Name.short
				Args(1) = PnP(obj)
				Args(2) = PnR(obj)
				Args(3) = PnO(obj)
				Args(4) = Not obj.IsDead
			Case "Family"			
				Args(1) = Dic("they")
				Args(2) = Dic("their")
				Args(3) = Dic("them")
				Args(4) = obj.AreTogether
			Case "Marriage"
				Args(1) = Dic("they")
				Args(2) = Dic("their")
				Args(3) = Dic("them")
				Args(4) = Not obj.AreTogether
			Case Else
				Args(1) = Dic("it")
				Args(2) = Dic("its")
				Args(3) = Dic("it")
				Args(4) = True
			End Select
			' create fixed part of Report.WritePhrase statement. N.B. params 5 - 9 are reserved but not used at present
			strExecute = "Report.WritePhrase strFmtTemplate, Args(0), Args(1), Args(2), Args(3), " & Util.IfElse(Args(4),"True","False") & _
									 ","""", """", """", """", """""
			' now add Custom Tag contents as param 10 onwards.
			For j = 2 to Ubound(Layout)
				strTag = Layout(j)
				If strTag <> "" Then
					Args(j+3) = CustomTag(obj,strTag)
				End If
				strExecute = strExecute & ", Args(" & j+3 & ")"
			Next
			cchBufferNow = Report.BufferLength
			Execute strExecute
			If Report.BufferLength > cchBufferNow Then
				cchBufferStart = -1	  ' indicate at least one value present in this Custom Tag Dialog Layout
			End If

			Report.WriteLn "</li></ul></li>"
		Else						' no custom template 
								' so create a collapse/expand section with the
								' custom tags in a table.

			Report.WriteFormattedLn "<br /><li class='xT2-{} xT-h' onclick='xTclk(event,""2"")'>", Util.IfElse(g_fCollapseReferences, "c", "o")
			Report.WriteFormattedLn "<span class='xT-i subhead bold'>{&t}</span><ul class='xT-h'><li><table class='customtagtable'>", Layout(1)
			For j = 2 to Ubound(Layout)
				strTag = Layout(j)
				strCustomTagData = Util.IfElse(strTag <> "", CustomTag(obj,strTag), "")

				If strCustomTagData <> "" Then
					strCustomTagDesc = oCustomTagDictionary.KeyValue(strTag)
					Report.WriteFormattedLn "<tr><td>{&t}</td><td>{&t}</td></tr>",strCustomTagDesc, strCustomTagData
					cchBufferStart = -1	  ' indicate at least one value present in this Custom Tag Dialog Layout
				End If
			Next

			Report.WriteLn "</table></li></ul></li>"
		End If

		If cchBufferStart > 0 Then ' no Custom Tags set in this Dialog Layout Section so remove phrase or table
			Report.BufferLength = cchBufferStart
		Else
			cchBufferBegin = -1 ' indicate at least one custom tag set
		End If
	Next
	Report.WriteLn "</ul></li></ul></div>"
	If cchBufferBegin > 0 Then	' no Custom tags present so remove the Additional Information section
		Report.BufferLength = cchBufferBegin
	Else
		g_ichReferencesStart = -1	' indicate at least one expand/collapse non-note item present
	End If
End Sub

Sub WriteHtmlRelationships(i)
	Dim strPnO, strPnp, strTitle, fAlive, fExtant, r, oRepertoryEntity, strConnection, strConnections
	strPnP = Util.StrFirstCharUCase(PnP(i))
	strPnO = PnO(i)

	Set oRepertoryEntity1 = Session("oRepertoryEntity1")
	Set oRepertoryEntity2 = Session("oRepertoryEntity2")

	If oRepertoryEntity1.KeyCounter(i.ID) > 0 Or _
		oRepertoryEntity2.KeyCounter(i.ID) > 0 Then
		If oRepertoryEntity1.KeyCounter(i.ID) > 0 Then
			Set oRepertoryEntity = oRepertoryEntity1.Entry(i.ID)
			strName = i.Name.short
			For Each r In oRepertoryEntity
				Report.WriteLn "<div class='clearleft'>"
				If (r.Pictures.Count > 0) Then
					Report.WriteLn "<div class='floatleft aligncenter widthpaddedsmall'>"
					WriteHtmlPicturesSmall r, "left", g_fHidePictureName
					Report.WriteLn "</div>"
				End If
				WriteHtmlRelationship r, strName, "", True
				WriteHtmlAdditionalInformation(r)
				WriteHtmlAnnotation Dic("AnnotationRelationship"), r.Comment
				strName = strPnP
				Report.WriteLn "</div>"
			Next
		End If
		If oRepertoryEntity2.KeyCounter(i.ID) > 0 Then
			Set oRepertoryEntity = oRepertoryEntity2.Entry(i.ID)
			strName = i.Name.Short
			For Each r In oRepertoryEntity
				Report.WriteLn "<div class='clearleft'>"
				If (r.Pictures.Count > 0) Then
					Report.WriteLn "<div class='floatleft aligncenter widthpaddedsmall'>"
					WriteHtmlPicturesSmall r, "left", g_fHidePictureName
					Report.WriteLn "</div>"
				End If
				strConnection = ""
				If r.Class = "SocialRelationship" Then
					strConnection = r.Connection.ID
				Else
					strConnection = r.EmotionalLink.ID
				End If
				Select Case strConnection
				Case "Roommate", "LivesWith", "Neighbor", "Acquaintance" ' two way relationship so keep individual as subject (i.e. 1st)
					WriteHtmlRelationship r, Util.IfElse(strName <> strPnO, strName, strPnP),  StrHtmlHyperlinkNN(r.entity1), True
				Case Else
					If strConnection = "" Then strConnection = " "
					Select Case Left(strConnection,3)
					Case "Abu", "Man", "Con", "Foc", "Fan", "Lim", "Jea"
						WriteHtmlRelationship r, "", strName, True
					Case Else
						If r.Class = "EmotionalRelationship" Then
							WriteHtmlRelationship r, Util.IfElse(strName <> strPnO, strName, strPnP),  StrHtmlHyperlinkNN(r.Entity1), True 
						Else 
							WriteHtmlRelationship r, "", strName, True
						End If
					End Select
				End Select
				WriteHtmlAdditionalInformation(r)
				WriteHtmlAnnotation Dic("AnnotationRelationship"), r.Comment
				Report.WriteLn "</div>"
				strName = strPnO
			Next
		End If
	End If
End Sub	

' Write the HTML code to display notes and comments for birth, death, education, occupation, etc.
Sub WriteHtmlAnnotation(strAnnotationType, strAnnotationCommentFull)
	Dim strAnnotationComments, strAnnotationComment
	Dim strParsedComment, strParse, Match
	strAnnotationComments = split(strAnnotationCommentFull,Dic("Private"))
	If Ubound(strAnnotationComments) >= 0 Then strAnnotationComment = strAnnotationComments(0)
	Set strParse = new RegExp
	strParse.Pattern ="((http|https|ftp)://[%:;/!@=&\$\-\.\+\*\(\)\,\?\w]+(\{[\x20-\x7c\x7e-\xff]+\})?)"
	strParse.Global=True
	strParse.IgnoreCase=True
	strComment = strAnnotationComment
	Set strParsedComment = strParse.Execute(strAnnotationComment)
	If strParsedComment.Count >0 Then
		nPos=1
		strAnnotationComment = ""
		For Each Match in strParsedComment
			Report.LogWarning "File " & Report.FileOutput & " contains URL: " & Match.Value
			n = Match.FirstIndex - nPos + 1
			strAnnotationComment =  strAnnotationComment & Util.HtmlEncode(Mid(strComment,nPos,n))
			If Right(Match.Value,1)="}" Then
				strSplit = Split(Left(Match.Value,Match.Length-1),"{",-1,1)
				strAnnotationComment = strAnnotationComment & _
					"<a href=""" & Util.HrefEncode(strSplit(0)) & """ target=""_top"">" & Util.HtmlEncode(strSplit(1)) & "</a>"
			Else
				strAnnotationComment = strAnnotationComment & _
					"<a href=""" & Util.HrefEncode(Match.Value) & """ target=""_top"">" & Util.HtmlEncode(Match.Value) & "</a>"
			End If
			nPos = nPos + n + Match.Length
		Next
		strAnnotationComment = strAnnotationComment & Util.HtmlEncode(Mid(strComment,nPos))
	Else
		strAnnotationComment =  Util.HtmlEncode(strComment)
	End If
	If (strAnnotationComment <> "") Then
		g_ichNotesStart = -1	' Use a negative value to indicate the presence of an annotation
		Report.WriteFormattedLn	"<ul class='xT note'>" & vbNewline & _
				     	"  <li class='xT-{} xT-h' onclick='xTclk(event,"""")'>{&t}" & vbNewline & _
				     	"    <ul class='xT-n'>" & vbNewline & _
				     	"     <li class='xT-b xT-n'>{}" & vbNewline & _
				     	"     </li>" & vbNewline & _
				     	"    </ul>" & vbNewline & _
					"  </li>" & vbNewline & _
					"</ul>" & vbNewline, _
					Util.IfElse(g_fCollapseNotes, "c", "o"), strAnnotationType, strAnnotationComment
	End If
End Sub

' Write the HTML code to display the comment of the primary picture (if present)
' If the picture does not have a description, the code must be written, otherwise
' the slideshow will abort by a script error
Sub WriteHtmlAnnotationPicture(strAnnotationType, obj, strAlign, nWidth )

	Dim p, strId, strClass, strDescription
	Set p = obj.Pictures.Primary
	If (Not Util.IsNothing(p)) Then
		strId = obj.ID
		strClass = "show"
		Dim strDescriptions
		strDescriptions = split(p.Description,Dic("Private"))
		If Ubound(strDescriptions) >= 0 Then strDescription = Util.HtmlEncode(strDescriptions(0))
		If (strDescription = "") Then
			strDescription = "&#32;"
			strClass = "hide"
		Else
			g_ichNotesStart = -1	' Use a negative value to indicate the presence of an annotation
		End If
		Report.WriteFormattedLn "<ul id='idPVv_{}' class='xT {} note'>", strId, strClass
		Report.WriteFormattedLn "    <li class='xT-{} xT-h' onclick='xTclk(event,"""")'>{&t}", Util.IfElse(g_fCollapseNotes, "c", "o"), Dic.FormatString("FmtAnnotationPicture", strAnnotationType)
		Report.WriteFormattedLn "        <ul class='xT-n'><li id='idPVd_{}' class='xT-b xT-n'>{}</li></ul>", strId, strDescription
		Report.WriteLn          "    </li>"
		Report.WriteLn          "</ul>"
	End If
End Sub

' Write details associated with a primary picture with a specific HTML id so that it can be overwritten for each picture in a slideshow if required
Sub WriteHtmlDetailsPicture(obj, fNoName, fBr)
	Dim p, strId
	Set p = obj.Pictures.Primary	' Get the primary picture of the object
	If p.PictureDimension <> "" Then
		strId = obj.ID
		Report.WriteFormattedLn "<div class='caption' id='idPVc_{}'>{}</div>", strId, LanguageDictionary.FormatPhrase("PhPictureDetailsHtml", Util.IfElse(fNoName, "",StrHtmlTag(Trim(p.Name),"strong")), p.Date.ToStringNarrative, StrHtmlHyperlink(p.Place), StrHtmlHyperlink(p.Source))
	End If
End Sub

' Write a reference to a footnote item
' This routine requires the presence of a GenoCollection object named g_collFootnotes to store
' the unique footnotes.
Sub WriteHtmlFootnoteRef(oFootnote)
	If (Not Util.IsNothing(oFootnote)) Then
		Dim iFootnote		' Zero-based index representing the position where the footnote is found in the collection
		iFootnote = g_collFootnotes.AddUnique(oFootnote)
		Report.WriteFormatted "<sup><a href='#{0}' title='{}'>{0}</a>&nbsp;</sup>", iFootnote + 1, Dic("SourceFootnote")
	End If
End Sub

' Write a reference for two footnotes.  If both footnotes are identical,
' then write only a single footnote
Sub WriteHtmlFootnoteRef2(oFootnote1, oFootnote2)
'	If (Not Util.AreObjectsEqual(oFootnote1, oFootnote2)) Then
	If oFootnote1 <> oFootnote2 Then
		WriteHtmlFootnoteRef oFootnote1
	End If
	WriteHtmlFootnoteRef oFootnote2
End Sub

Sub WriteHtmlFootnoteRefs(oFootnotes)
	For Each oFootnote in oFootnotes.ToGenoCollection
		WriteHtmlFootnoteRef(oFootnote)
	Next
End Sub

' Write all the footnotes to the report
Sub WriteHtmlAllFootnotes(oSources)
Dim collSources
Set collSources = Util.NewGenoCollection()
If Not Util.IsNothing(OSources) Then collSources.Add(oSources.ToGenoCollection)
If (g_collFootnotes.Count > 0) Or (collSources.Count > 0) Then
		Report.WriteLn "<div class='footnote clearleft'><br />"
		If (g_collFootnotes.Count > 0) Then
			Dim iFootnote, oFootnote, strTitle, strSep, s
			iFootnote = 0
			For Each oFootnote In g_collFootnotes
				iFootnote = iFootnote + 1
				strTitle = Util.FirstNonEmpty(oFootnote.Subtitle, oFootnote.Description, oFootnote.QuotedText, Dic("SourceInformation"))
				If (strTitle <> "") Then
					strTitle = Util.FormatString(" title='{&t}'", strTitle)
				End If
				Report.WriteFormattedBr "<sup><a name='{0}'></a>{0} </sup> <a href='source-{&t}.htm' onclick='javascript:showPopUpFrame("""");' target='popup' {}><i>{&t}</i></a>", iFootnote, oFootnote.ID, strTitle, JoinSourceCitationNames(oFootnote, oFootnote.title, true)
				' remove referenced source from list
				collSources.Remove(oFootnote)
			Next
			g_collFootnotes.clear
		End If
		If collSources.Count > 0 Then ' write details of remaining source/citations
			Report.Write "<br\>" & Dic.Plurial("SourceCitation" & Util.IfElse(g_collFootnotes.Count > 0, "_Other",""), collSources.Count)
			strSep = ""
			For Each oFootnote in collSources
				strTitle = Util.FirstNonEmpty(oFootnote.Subtitle, oFootnote.Description, oFootnote.QuotedText, Dic("SourceInformation"))
				If (strTitle <> "") Then
					strTitle = Util.FormatString(" title='{&t}'", strTitle)
				End If
				Report.WriteFormatted strSep & " <a href='source-{&t}.htm' onclick='javascript:showPopUpFrame("""");' target='popup' {}><i>{&t}</i></a>", oFootnote.ID, strTitle, JoinSourceCitationNames(oFootnote, oFootnote.title, true)
				strSep = ","
			Next
		End If
		Report.WriteLn "</div>"
	End If
End Sub


' This method writes the HTML code to make sure the entire report is accessible from any page.
' Do not remove this safeguard; it may affect the navigation of the report.
' The text is written in English because it is very rare someone will actually read it.  This text is not
' the most eloquent English, however it contains a wealth of keywords for surfers to quickly find your
' genealogy report if published on the web.
' The text should be translated to include keywords in your language.
Sub WriteHtmlFramesetSafeguardK(s, k, o)
	Report.WriteLn "<div id='divFrameset' class='hide'> <hr /><p><br />"
	Dim strHref, strName, strNameFamilies, strNamePedigrees
	strHref = "toc_individuals.htm"
	If (Not Util.IsNothing(o)) Then
		' Report.WriteFormattedBr "This page charts the <b>family history of {0&t}</b>. Follow the links below to <i>find more people</i> having <b>pedigree roots with {0&t}</b> and the <b>ancestry of {0&t}</b>.", o
		If (o.Class = "Individual") Then
			strName = " of " & o.Name.Last
			strNameFamilies = strName & " families"
			strNamePedigrees = strName & " pedigrees"
			strNameHeritage = strName & " heritage from """ & Session("Title") & """"
			strName = "#" & o.Name.Last
			k = ""
		ElseIf (o.Class = "Family") Then
			strNameFamilies = " of family " & o
			strHref = "toc_families.htm"
			k = ""
		End If
	End If	
	Report.WriteFormattedBr "This page is within a frameset.  <b><a target='_top' href='default.htm'>View the entire genealogy report{&t}</a></b>, or " & _
		"<a href='{}{&t}'>surname index{&t}</a> or <a href='home.htm'>report summary{&t}</a>.", _
		strNameFamilies, strHref, strName, strNamePedigrees, strNameHeritage
	Report.WriteT3Br "(", k, ")"
	Report.WriteFormatted "{}.</p><hr /><br /><p class='aligncenter'><small> 2006 GenoPro Inc.  All Rights Reserved.</small></p></div>", Dic.SearchKeywordHyperlink
End Sub

Sub WriteHtmlFramesetSafeguard(s)
	WriteHtmlFramesetSafeguardK s, "", nothing
End Sub

' Write the report description for the META tag.
' This routine is used by default.htm, header.htm and home.htm.
Sub WriteMetaDescriptionReport

	Report.WritePhrase "Summary report of {0} containing {1} individuals and {2} families.  ", Session("Title"), Individuals.Count, Families.Count
	Report.WriteText "This report describes the genealogy and ancestry of families "

	Dim oStringDictionaryNames, iName, iNameLast, strSep
	Set oStringDictionaryNames = Session("oStringDictionaryNames")
	If (Not Util.IsNothing(oStringDictionaryNames)) Then
		iNameLast = oStringDictionaryNames.Count - 1
		If (iNameLast > 9) Then
			iNameLast = 9		' Keep only the first 10 families
		End If
		strSep = ""
		For iName = 0 To iNameLast
			Report.WriteText strSep & oStringDictionaryNames.Key(iName)
			strSep = ", "
		Next
	End If
	Report.WriteText "."
End Sub

' Write the report keywords for the META tag.
Sub WriteMetaKeywordsReport
	Report.Write "Family Report, Genealogy Report, Family Tree, Family Search"
End Sub

Function GetDate(oDate)
	If Not Util.IsNothing(oDate) Then GetDate = Util.FormatPhrase(Dic("FmtDateSort"), oDate.Year, Util.IfElse(oDate.Month<>"",Right("0" & oDate.Month,2),""), Util.IfElse(oDate.Day<>"",Right("0" & oDate.Day,2),""))
End Function

Function MatchDate(o, p, obj)
	If o.Id = p.ID And obj.ToStringNarrative <> "" Then
		Set MatchDate = obj
	Else
		Set MatchDate = Nothing
	End If
End Function

' Check the Private tag
Function isPrivate(obj)
	Select Case obj.Class
	Case "Individual"
		' An individual is private according to the Private custom tag.
		' If the tag is not defined, an individual is private unless dead.
		Select Case CustomTag(obj,"Private")
			Case "Y"  
				isPrivate = True
			Case "N"
				isPrivate = False
			Case Else
				On Error Resume Next 
				If obj.isDead Then isPrivate = False Else isPrivate = True
		End Select
	Case "Family"
		' A family is private if either of the parents is private
		isPrivate = Eval((isPrivate(obj.Parents(0)) Or isPrivate(obj.Parents(1))))
	Case "Picture"
		' A picture is private unless it is referenced by at least one public object
		isPrivate = True
		If obj.References.Count Then
			For Each r in obj.References
				If Not isPrivate(r) Then
					isPrivate = False
					Exit For
				End If
			Next
		End If
	Case Else
		' All other objects are public.
		isPrivate = False
	End Select
End Function

' The above "isPrivate" function cannot be used for GenoMaps, as they do not have the Class attribute.
' So a special-case function just for GenoMaps is provided.
Function isPrivateGenoMap(g)
	isPrivateGenoMap = True
	For Each o in g.DrawingObjects.ToGenoCollection
		If o.Class = "Individual" And Not isPrivate(o) Then
			isPrivateGenoMap = False
			Exit For
		End If
	Next
End Function
